
/**************************************************
* Modbus TCP connection management
**************************************************/
void doModbusTcp(u8 socket, u16 port, u16* registerMemory, u8* coilMemory)
{		
	switch(netStatus(socket))
	{
		case SOCK_CLOSED:
			//Open socket if closed
			socketOpen(socket, port);
			break;
			
		case SOCK_INIT:
			//Start listening if socket is open
			listen(socket);
			break;
			
		case SOCK_ESTABLISHED:	
			//process any modbus TCP requests if client is connected
			processModbusTcpRequest(socket, registerMemory, coilMemory);
			break;
	}	
}

/**************************************************
* Main test routine
**************************************************/
void cmain(void)
{
   //Network Settings
	u8 gatewayIP[]={192,168,0,2};
	u8 subnetMask[]={255,255,255,0};
	u8 macAdr[]={0,0,34,53,12,0};
	u8 moaconIp[]={192,168,0,12};
	netBegin(gatewayIP, subnetMask, macAdr, moaconIp);
	
	//Modbus Settings
	u8 socket = 0;
	u16 port = 502;
	static u8 coilMemory[8];
	static u16 registerMemory[8];
	
	//make sure the socket is closed before starting
	disConnect(socket);
	socketClose(socket);

	//Continually poll the socket to process modbus TCP requests
	while(1)
	{
		doModbusTcp(socket, port, registerMemory, coilMemory);
	}
}

